EAPI=5

EGIT_REPO_URI="https://github.com/mosra/magnum-examples.git"

inherit cmake-utils git-r3

DESCRIPTION="Examples for the Magnum C++11/C++14 graphics engine"
HOMEPAGE="https://magnum.graphics"

LICENSE="public-domain"
SLOT="0"
KEYWORDS="~amd64 ~x86"
IUSE=""

RDEPEND="
	dev-libs/magnum
	dev-libs/magnum-plugins
	dev-libs/magnum-integration
	dev-libs/magnum-extras
	dev-libs/box2d
	media-libs/openal
	sci-physics/bullet
"
DEPEND="${RDEPEND}"

src_configure() {
    # general configuration
	local mycmakeargs=(
		-DCMAKE_INSTALL_PREFIX="${EPREFIX}/usr"
		-DCMAKE_BUILD_TYPE=Debug
		-DMAGNUM_WITH_ANIMATED_GIF_EXAMPLE=ON
		-DMAGNUM_WITH_ARCBALL_EXAMPLE=ON
		-DMAGNUM_WITH_AREALIGHTS_EXAMPLE=ON
		-DMAGNUM_WITH_AUDIO_EXAMPLE=ON
		-DMAGNUM_WITH_BOX2D_EXAMPLE=ON
		-DMAGNUM_WITH_BULLET_EXAMPLE=ON
		-DMAGNUM_WITH_CUBEMAP_EXAMPLE=ON
		-DMAGNUM_WITH_DART_EXAMPLE=OFF
		-DMAGNUM_WITH_FLUIDSIMULATION2D_EXAMPLE=OFF
		-DMAGNUM_WITH_FLUIDSIMULATION3D_EXAMPLE=OFF
		-DMAGNUM_WITH_IMGUI_EXAMPLE=OFF
		-DMAGNUM_WITH_MOTIONBLUR_EXAMPLE=ON
		-DMAGNUM_WITH_MOUSEINTERACTION_EXAMPLE=ON
		-DMAGNUM_WITH_OCTREE_EXAMPLE=ON
		-DMAGNUM_WITH_PICKING_EXAMPLE=ON
		-DMAGNUM_WITH_PRIMITIVES_EXAMPLE=ON
		-DMAGNUM_WITH_RAYTRACING_EXAMPLE=ON
		-DMAGNUM_WITH_SHADOWS_EXAMPLE=ON
		-DMAGNUM_WITH_TEXT_EXAMPLE=ON
		-DMAGNUM_WITH_TEXTUREDQUAD_EXAMPLE=ON
		-DMAGNUM_WITH_TRIANGLE_EXAMPLE=ON
		-DMAGNUM_WITH_TRIANGLE_PLAIN_GLFW_EXAMPLE=OFF
		-DMAGNUM_WITH_TRIANGLE_SOKOL_EXAMPLE=OFF
		-DMAGNUM_WITH_VIEWER_EXAMPLE=ON
	)
	cmake-utils_src_configure
}

# kate: replace-tabs off;
